{**************************************************************************}
{ TAdvReflectionLabel & TAdvReflectionImage component demo                 }
{                                                                          }
{ written by TMS Software                                                  }
{            copyright  2007 - 2008                                       }
{            Email : info@tmssoftware.com                                  }
{            Website : http://www.tmssoftware.com/                         }
{                                                                          }
{ The source code is given as is. The author is not responsible            }
{ for any possible damage done due to the use of this code.                }
{ The component can be freely used in any application. The complete        }
{ source code remains property of the author and may not be distributed,   }
{ published, given or sold in any form as such. No parts of the source     }
{ code can be included in any other component or application without       }
{ written authorization of the author.                                     }
{**************************************************************************}

unit UReflCreator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AdvReflectionImage, StdCtrls, ExtCtrls, ComCtrls, AdvReflectionLabel;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    AdvReflectionImage1: TAdvReflectionImage;
    AdvReflectionLabel1: TAdvReflectionLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    FontDialog1: TFontDialog;
    Label8: TLabel;
    Label9: TLabel;
    TrackBar4: TTrackBar;
    Panel2: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    ColorDialog1: TColorDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Label11Click(Sender: TObject);
    procedure AdvReflectionLabel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SyncTrackbars;
  end;

var
  Form2: TForm2;

implementation

uses
  ShellApi;

{$R *.dfm}

procedure TForm2.AdvReflectionLabel1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    colordialog1.Color := AdvReflectionLabel1.Color;
    if colordialog1.Execute then
      AdvReflectionLabel1.Color := colordialog1.Color;
  end;

end;

procedure TForm2.Button1Click(Sender: TObject);
var
  fn: string;
  iftype: AdvReflectionImage.TImageType;
  lftype: AdvReflectionLabel.TImageType;
begin

  if savedialog1.Execute then
  begin
    fn := uppercase(savedialog1.FileName);
    if pagecontrol1.ActivePageIndex = 0 then
    begin
      iftype := AdvReflectionImage.itPNG;
      if pos('.JPG', fn) > 0 then
        iftype := AdvReflectionImage.itJPEG;
      if pos('.GIF', fn) > 0 then
        iftype := AdvReflectionImage.itGIF;
      if pos('.BMP', fn) > 0 then
        iftype := AdvReflectionImage.itBMP;

      advreflectionimage1.SaveToFile(savedialog1.FileName, iftype);
    end
    else
    begin
      lftype := AdvReflectionlabel.itPNG;
      if pos('.JPG', fn) > 0 then
        lftype := AdvReflectionlabel.itJPEG;
      if pos('.GIF', fn) > 0 then
        lftype := AdvReflectionlabel.itGIF;
      if pos('.BMP', fn) > 0 then
        lftype := AdvReflectionlabel.itBMP;

      advreflectionlabel1.SaveToFile(savedialog1.FileName, lftype);
    end;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if opendialog1.Execute then
  begin
     advreflectionimage1.Picture.LoadFromFile(opendialog1.Filename);
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(AdvReflectionLabel1.Font);

  if FontDialog1.Execute then
  begin
    AdvReflectionLabel1.Font.Assign(FontDialog1.Font);
  end;
end;

procedure TForm2.Edit1Change(Sender: TObject);
begin
  AdvReflectionLabel1.HTMLText.Text := Edit1.Text;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  SyncTrackbars;
//  pagecontrol1.DoubleBuffered := true;
//  tabsheet1.DoubleBuffered := true;
end;

procedure TForm2.Label11Click(Sender: TObject);
begin
  ShellExecute(0,'open',pchar(label11.Caption),nil,nil,SW_NORMAL);
end;

procedure TForm2.PageControl1Change(Sender: TObject);
begin
  SyncTrackBars;
end;

procedure TForm2.SyncTrackbars;
begin
  if pagecontrol1.ActivePageIndex = 0 then
  begin
    trackbar1.Position := advreflectionimage1.ReflectionSize;
    trackbar2.Position := advreflectionimage1.ReflectionOpacityStart;
    trackbar3.Position := advreflectionimage1.ReflectionOpacityEnd;
    trackbar4.Position := advreflectionimage1.ReflectionAxis;
  end
  else
  begin
    trackbar1.Position := advreflectionlabel1.ReflectionSize;
    trackbar2.Position := advreflectionlabel1.ReflectionOpacityStart;
    trackbar3.Position := advreflectionlabel1.ReflectionOpacityEnd;
    trackbar4.Position := advreflectionlabel1.ReflectionAxis;
  end;
end;

procedure TForm2.TrackBar1Change(Sender: TObject);
begin
  if pagecontrol1.ActivePageIndex = 0 then
    advreflectionimage1.ReflectionSize := trackbar1.Position
  else
    advreflectionlabel1.ReflectionSize := trackbar1.Position;  

  label2.Caption := inttostr(trackbar1.Position);
end;

procedure TForm2.TrackBar2Change(Sender: TObject);
begin
  if pagecontrol1.ActivePageIndex = 0 then
    advreflectionimage1.ReflectionOpacityStart := trackbar2.Position
  else
    advreflectionlabel1.ReflectionOpacityStart := trackbar2.Position;
    
  label5.Caption := inttostr(trackbar2.Position);
end;

procedure TForm2.TrackBar3Change(Sender: TObject);
begin
  if pagecontrol1.ActivePageIndex = 0 then
    advreflectionimage1.ReflectionOpacityEnd := trackbar3.Position
  else
    AdvReflectionLabel1.ReflectionOpacityEnd := trackbar3.Position;

  label6.Caption := inttostr(trackbar3.Position);
end;

procedure TForm2.TrackBar4Change(Sender: TObject);
begin
  if pagecontrol1.ActivePageIndex = 0 then
    advreflectionimage1.ReflectionAxis := trackbar4.Position
  else
    AdvReflectionLabel1.ReflectionAxis := trackbar4.Position;

  label9.Caption := inttostr(trackbar4.Position);
end;

end.
